#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    600
#define SCREEN_HEIGHT   600

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Sandpiles 8", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    static int table[SCREEN_WIDTH + 2][SCREEN_HEIGHT + 2];

    // initialise the table
    for (int y = 1; y <= SCREEN_HEIGHT; ++y)
        for (int x = 1; x <= SCREEN_WIDTH; ++x)
            table[x][y] = (y > x ? 1 : 0);

    int cx = SCREEN_WIDTH / 2;
    int cy = SCREEN_HEIGHT / 2;
    table[cx][cy] = 400000;

    // init palette
    Color palette[5];
    palette[0] = Color(0, 0, 255);
    palette[1] = Color(0, 255, 255);
    palette[2] = Color(255, 255, 0);
    palette[3] = Color(255, 0, 0);
    palette[4] = Color(255, 255, 255);

    int counter = 0;

    while (sys.isQuitRequested() == false)
    {
        // draw the current table
        for (int y = 0; y < SCREEN_HEIGHT; ++y)
            for (int x = 0; x < SCREEN_WIDTH; ++x)
            {
                int color = table[x + 1][y + 1];

                if (color > 4)
                    color = 4;
                gfx.setPixel(x, y, palette[color]);
            }

        counter++;
        if ((counter % 16) == 0)
            gfx.render();

        sys.processEvents();

        // update the table
        int screenSize = (SCREEN_WIDTH + 2) * (SCREEN_HEIGHT + 2);

        for (int y = 1; y <= SCREEN_HEIGHT; ++y)
            for (int x = 1; x <= SCREEN_WIDTH; ++x)
            {
                int height = table[x][y] / 4;
                table[x][y] -= height * 4;
                table[x - 1][y] += height;
                table[x + 1][y] += height;
                table[x][y - 1] += height;
                table[x][y + 1] += height;
            }
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
